﻿# Créé par Elias Berrabah, le 15/11/2019 en Python 3.4
''' FICHE 1 : Matplotlib et probabilités '''

#Proposition d’exo 3 : marche aléatoire à une dimension et applications

from matplotlib.pyplot import *
import random
from utile import *

def deplacement_aleatoire():

    return random.choice([-1,1])

def simulation(pas):

    abscisses = [i for i in range(pas+1)]
    ordonnees = [0]
    for k in range(1,pas+1):
        choix = deplacement_aleatoire()
        ordonnees.append(ordonnees[k-1]+choix)
    plot(abscisses,ordonnees)
    axesnormaux()

def retour_en_0(pas):
    """ retourne 1 si la marche aléatoire fait un retour en 0 et 0 sinon """

    abscisses = [i for i in range(pas+1)]
    ordonnees = [0]
    for k in range(1,pas+1):
        choix = deplacement_aleatoire()
        ordonnees.append(ordonnees[k-1]+choix)

    if 0 in ordonnees[1:]:  #si 0 est dans la liste ordonnees (en enlevant l'élément d'indice 0 qui vaut tjrs 0)
        return 1
    else:
        return 0

def proba_retour_0(pas):
    somme=0
    for k in range(10000):
        somme += retour_en_0(pas)
    return somme/10000

def simu2(nb_haut,nb_bas):
    pas = nb_haut+nb_bas
    abscisses = [i for i in range(pas+1)]
    liste_choix = [1]*nb_haut+[-1]*nb_bas
    random.shuffle(liste_choix) # on mélange
    ordonnees = [0]
    for k in range(1,pas+1):
        choix = liste_choix[k-1]
        ordonnees.append(ordonnees[k-1]+choix)
    plot(abscisses,ordonnees)
    axesnormaux()


def que_positif(nb_haut,nb_bas):
    """ retourne True ou False """
    fin = nb_haut+nb_bas
    abscisses = [i for i in range(fin+1)]
    liste_choix = [1]*nb_haut+[-1]*nb_bas
    random.shuffle(liste_choix) # on mélanges
    ordonnees = [0]
    for k in range(1,fin+1):
        choix = liste_choix[k-1]
        if choix == 1:
            ordonnees.append(ordonnees[k-1]+1)
        else:
            ordonnees.append(ordonnees[k-1]-1)
        if ordonnees[k]<0:
            return False
    # si on arrive à la fin de la boucle, c'est qu'on est jamais passé du côté des négatifs, et donc on retourne True
    return True

def scrutin(nb_voix_A,nb_voix_B):
    """ le candidat A a + de voix que le B. Quelle est la probabilité qu'il ait été tjrs en tête lors du dépouillement au sens large (dc égalité inclus)?
     """
    # cette proba vaut en réalité (nb_voix_A - nb_voix_B+1) / (nb_voix_A + 1) * (nb_voix_A parmi nb_voix_A + nb_voix B)
    somme=0
    for k in range(10000):
        if que_positif(nb_voix_A,nb_voix_B):
            somme +=1
    return somme/10000



