﻿# Créé par Elias Berrabah, le 15/11/2019 en Python 3.4
''' FICHE NUMERO 3 : Matplotlib/numpy et fonctions '''

from matplotlib.pyplot import *
from numpy import *
from utile import *  # module où la fonction axesnormaux() est définie


# Proposition d’exercice 1 : Autour des fonctions définies par morceaux

def f(x):
    if x<0:
        return x**2+1
    else:
        return 3*x+1

def affiche():
    abscisses = linspace(-10,10,100)
    ordonnees = [f(x) for x in abscisses]
    plot(abscisses,ordonnees)
    axesnormaux()
    show()


# Proposition d’exercice 2 : Calcul de l’impôt brut

def impots(revenu):

    if revenu<=9964:
        return 0
    elif 9964 < revenu <= 27519:
        return (revenu - 9964)*0.14
    elif 27519 < revenu <= 73779:
        return 2457.7+ (revenu-27519)*0.30
    elif 73779 < revenu <= 156244:
        return 16335.7 + (revenu - 73779)*0.41
    else:
        return 50146.35+ (revenu - 156244)*0.45


def affiche_impots(a,b):

    # on peut faire autrement mais comme la fonction est affine par morceaux, il suffit de ce concentrer sur les points les plus importants

    abscisses = [0,9964,27519,73779,156244,200000]
    ordonnees = [impots(x) for x in abscisses]
    plot(abscisses,ordonnees)
    show()

# Proposition d’exercice 3 : Tracer la dérivée d’une fonction (sans connaître son expression)

def derivee(f,a,b):

    x = arange(a,b,0.05) # prendre un pas petit
    ordonnees = [(f(x[i+1]) - f(x[i]))/(x[i+1]-x[i]) for i in range(len(x)-1)]
    plot(x[:-1],ordonnees)
    axesnormaux()
    show()
    title("Représentation graphique de la fonction dérivée sur [{};{}]".format(a,b))


